(* = DiffAppl.ML
   +++ outcommented tests
*)


theory' := overwritel (!theory', [("DiffAppl",DiffAppl.thy)]);

(* 
> get_pbt ["DiffAppl","maximum_of","function"];
> get_met ("Script","max_on_interval_by_calculus");
> !pbltypes;
  *)
pbltypes:= overwritel (!pbltypes,
[
 prep_pbt DiffAppl.thy
 (["DiffAppl","maximum_of","function"],
  [("#Given" ,"fixedValues f_ix"),
   ("#Find"  ,"maximum m_"),
   ("#Find"  ,"valuesFor v_s"),
   ("#Relate","relations r_s")  (*,
   ("#where" ,"foldl (op&) True (map (Not o ((op<=) #0) o Rhs) f_ix)"),
   ("#with"  ,"Ex_frees ((foldl (op &) True r_s) &  \
    \ (ALL m'. (subst (m_,m') (foldl (op &) True r_s) \
    \            --> m' <= m_)))")    *)
  ]),

 prep_pbt DiffAppl.thy
 (["DiffAppl","make","function"]:pblID,
  [("#Given" ,"functionOf f_f"),
   ("#Given" ,"boundVariable v_v"),
   ("#Given" ,"equalities eqs"),
   ("#Find"  ,"functionTerm f_0_")
  ]),

 prep_pbt DiffAppl.thy
 (["DiffAppl","on_interval","maximum_of","function"]:pblID,
  [("#Given" ,"functionTerm t_"),
   ("#Given" ,"boundVariable v_v"),
   ("#Given" ,"interval itv_"),
   ("#Find"  ,"maxArgument v_0")
  ]),

 prep_pbt DiffAppl.thy
 (["DiffAppl","find_values","tool"]:pblID,
  [("#Given" ,"maxArgument ma_"),
   ("#Given" ,"functionTerm f_f"),
   ("#Given" ,"boundVariable v_v"),
   ("#Find"  ,"valuesFor vls_"),
   ("#Relate","additionalRels r_s")
  ])
]);


methods:= overwritel (!methods,
[
 (("DiffAppl","max_by_calculus"):metID,
  {ppc = prep_met DiffAppl.thy
   [("#Given" ,"fixedValues f_ix"),
    ("#Given" ,"boundVariable v_v"),
    ("#Given" ,"interval itv_"),
    ("#Given" ,"errorBound err_"),
    ("#Find"  ,"maximum m_"),
    ("#Find"  ,"valuesFor v_s"),
    ("#Relate","relations r_s")
    ],
   rew_ord'="tless_true",rls'="eval_rls",asm_rls=[],asm_thm=[],
   scr=EmptyScr} : met),

 (("DiffAppl","make_fun_by_new_variable"):metID,
  {ppc = prep_met DiffAppl.thy
   [("#Given" ,"functionOf f_f"),
    ("#Given" ,"boundVariable v_v"),
    ("#Given" ,"equalities eqs"),
    ("#Find"  ,"functionTerm f_0_")
    ],
   rew_ord'="tless_true",rls'="eval_rls",asm_rls=[],asm_thm=[],
   scr=EmptyScr} : met),

 (("DiffAppl","make_fun_by_explicit"):metID,
  {ppc = prep_met DiffAppl.thy
   [("#Given" ,"functionOf f_f"),
    ("#Given" ,"boundVariable v_v"),
    ("#Given" ,"equalities eqs"),
    ("#Find"  ,"functionTerm f_0_")
    ],
   rew_ord'="tless_true",rls'="eval_rls",asm_rls=[],asm_thm=[],
   scr=EmptyScr} : met),
  
 (("DiffAppl","max_on_interval_by_calculus"):metID,
  {ppc = prep_met DiffAppl.thy
   [("#Given" ,"functionTerm t_"),
    ("#Given" ,"boundVariable v_v"),
    ("#Given" ,"interval itv_"),
    ("#Given" ,"errorBound err_"),
    ("#Find"  ,"maxArgument v_0")
    ],
   rew_ord'="tless_true",rls'="eval_rls",asm_rls=[],asm_thm=[],
   scr=EmptyScr} : met),

 (("DiffAppl","find_values"):metID,
  {ppc = prep_met DiffAppl.thy
   [],
   rew_ord'="tless_true",rls'="eval_rls",asm_rls=[],asm_thm=[],
   scr=EmptyScr} : met)
]);
